#!/usr/bin/perl -w
# A perl script for executing HotKnots and computeEenery.
# single sequence only ! (the last sequence in a fasta file is used.)
#
# Usage:
# modena_dps.pl [fasta file] [hotknots/computeEnergy] [options]
# author: Akito Taneda
use strict ;

my $hotknotsBinDir = '~/bin/4HotKnots/bin' ;
#my $hotknotsBinDir = '~/prog/HotKnots_v2.0/bin' ;

my $prog = $ARGV[1] ;
my $options = $ARGV[2] ; # if no option, specify a ''
if ($prog ne 'hotknots' and $prog ne 'HotKnots' and $prog ne 'computeEnergy') {
   print "ERROR: a program name, $prog, is incorrect.\n" ;
   print "       (prog name = hotknots, HotKnots, or computeEnergy)\n" ;
   exit (1);
}

unless (open(IN,$ARGV[0])) {
   print "ERROR: input file cannot be opened.\n" ;
   exit (1);
} 

my $inp = '' ;
while(<IN>) {
   chomp;
   if (/^>\s*SecondaryStructure/) { last ; }
   if (/^>/) {
      $inp = ''
   } else {
      $_ =~ tr/a-z/A-Z/ ;
      $_ =~ s/[^ACGTU]/N/g ;
      $inp .= $_ ;
   }
}

# read a ss line
my $ss = '' ;
if ($prog eq 'computeEnergy') {
   while(<IN>) {
      chomp;
      if (/^>/) {
      } else {
         $ss .= $_ ;
      }
   }
}

my $len = length ($inp);
my $tempdir1 ; my $wrkmax = 99999 ;
for (my $i = 1 ; $i <= $wrkmax ; $i++) {
   $tempdir1 = 'modenaRNAsoft'.$i ;
   unless (-e $tempdir1) { last ; }
   if ($i == $wrkmax) { print "ERROR: work dir. cannot be creaetd.\n" ; exit (1) ; }
}

my $root = `pwd` ;
$root =~ s/\n$// ;
mkdir ($tempdir1) ;
chdir ($tempdir1) ;

# copy HotKnots' bin directory to a temp. directory.
system ("cp -r $hotknotsBinDir .");
mkdir ('temp') ;
chdir ('temp') ;

if ($prog eq 'hotknots' or $prog eq 'HotKnots') {
   $options .= " -s $inp -noPS -b " ;
   mkdir ('output') ;
   my @output = `HotKnots $options` ;

   foreach (@output) {
      chomp ;
      if (/^Seq:/) {
         $_ =~ s/^Seq:\s+// ;
         print "$_\n" ;
      } elsif (/^S0:\s+/) {
         my @a = split ;
         #$a[1] =~ s/^S0:\s+// ;
         print "$a[1] $a[2]\n" ;
      }
   }

} elsif ($prog eq 'computeEnergy') {
   $options = " -s $inp '$ss' " ;
   my @output = `computeEnergy $options` ; 
   print "$output[$#output]" ;
}

chdir ($root) ;
system ("rm -rf $tempdir1") ;
