#!/usr/bin/perl -w
# usage : modena_nonred.pl modnea_output_filename 
# mark redundant individual data by replacing "Individual" with "*Individual".
# '*Individual' keyword is skipped by modena_res.pl
# ver.01 author: Akito Taneda

use strict ;

#my $deleteRed = 'n' ;
my $deleteRed = 'y' ; # do not output redandant data (= data of *Individual)

my @output ;

open (IN, $ARGV[0]) ;
# skip lines
while (<IN>) { 
   push (@output, $_) ;
   if (/^DesignedSequences/) { last ; }
   if (/^LOOP/) { last ; }
}

my @data ;
while (<IN>) { push (@data, $_) ; }
close (IN) ;

my %hash ;
for (my $i = 0 ; $i < scalar (@data) ; $i++) {
   if ($data[$i] =~ /^Individual/) {
      if (exists ($hash{$data[$i + 1]})) {
         my $x = '*'.$data[$i] ;
         push (@output, $x) ;
      } else {
         $hash{$data[$i + 1]} = 1 ;
         push (@output, $data[$i]) ;
      }
   }
   else { push (@output, $data[$i]) ; }
}
close(IN);

if ($deleteRed eq 'y') {
   for (my $i = 0 ; $i < scalar (@output) ; $i++) {
      if ($output[$i] =~ /^\*Individual/) {
         while ($i < scalar (@output) and $output[$i] ne "\n") { $i++ ; }
      }
      else { print $output[$i] ; }
   }
} else {
   foreach (@output) { print ; }
}
